#!/bin/sh
#
# Tll voit luoda "kuittidatasta" oman datasetin 
# apriori-ohjelmaa varten, kts. dt_t4_m2 (tietokoneharj. 4,
# demo 2).
#
# Kaytt: ./kuitit_dataksi.sh
#
# Lukee tiedostot:
#   - kuitti_x.txt, jossa rivill yksi sana/tuote
#       vastaten kauppakuittia, x = (1, 2, 3, ...)
# Palauttaa tiedostot:
#   - data.txt, jokaisella rivill kunkin kauppakuitin ostokset
#   - data_x.txt, jossa kyseisen kauppakuitin x ostokset
#   - tuotteet.txt, jossa artikkelit kerralleen
#   - tuotteet.idx, jossa artikkelit kerralleen vastaavan ind.nron kanssa
#
# Tmn jlkeen voi ulostulotiedostoa data.txt kytt 
# apriori-ohjelmassa:
#
#   ./apriori data.txt 3 10 kattavat_joukot.txt
#
# jossa kattavan joukon kynnysarvona 10.
#
#
# T-61.2010
# Tietokoneharjoitus 4
# Jukka Parviainen, 7.12.2006

# Poistetaan vanhat data-tiedostot
rm -f data_*.txt
rm -f data.txt

# Poimitaan kaikki tuotteet kuiteista, sortataan ja poistetaan
# useat esiintymt
cat kuitti_*.txt | sort | uniq > tuotteet.txt
cat tuotteet.txt | egrep -n . > tuotteet.idx

# Jokaiselle kuitille kirjoitetaan tuotteen indeksinumerot
for b in `ls kuitti_*.txt`
do
  # poimitaan tiedoston numeroarvo x
  nro=`echo $b | cut -d"_" -f2 | cut -d"." -f1`

  # sortataan ja poistetaan duplikaatit yksittisen 
  # kuitin tuotteista
  cat kuitti_${nro}.txt | \
   sort | \
   uniq > dummy

  # sitten etsitn indeksinumerot diff-komennolla
   diff \
    --old-line-format='-%L' \
    --new-line-format='|%L' \
    --unchanged-line-format='*%L' \
   tuotteet.txt dummy | \
   egrep -n . | \
   fgrep "*" | \
   cut -d":" -f1 | \
   tr "\n" " " > data_${nro}.txt
 
  # fgrep -f kuitti.txt tuotteet.txt
  # toimii, muttei erota viili - kermaviili
  # 
  # fgrep -x -f kuitti.txt tuotteet.txt
  # toimii ja erottaa viili- kermaviili, 
  # mutta mist saadaan en oikeat sarakenumerot?

done 

# Muokataan yksittiset tuoteindeksit lopulliseksi tiedostoksi
for b in `ls data_*.txt`
do
  cat $b | tr "\n" " "  > dummy
  #| sed 's/[0-9] $/&1/' > dummy
  mv dummy $b
  cat $b >> data.txt
  echo " " >> data.txt
done
